/*
 *  Copyright (C) 2009
 *      Authors (alphabetical) :
 *              Klaus 'mrmoku' Kurzmann <mok@fluxnetz.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Public License as published by
 *  the Free Software Foundation; version 2 of the license.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser Public License for more details.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-bindings.h>
#include "frameworkd-glib-odeviced-input.h"
#include "frameworkd-glib-odeviced-dbus.h"
#include "dbus/input.h"

DBusGProxy *odevicedInputBus = NULL;


static int
odeviced_input_get_source_from_dbus(char *source)
{
	if (!strcmp(source, DBUS_DEVICE_INPUT_SOURCE_AUX)) {
		return DEVICE_INPUT_SOURCE_AUX;
	}
	else if (!strcmp(source, DBUS_DEVICE_INPUT_SOURCE_POWER)) {
		return DEVICE_INPUT_SOURCE_POWER;
	}
	return DEVICE_INPUT_SOURCE_UNKNOWN;
}

static int
odeviced_input_get_action_from_dbus(char *action)
{
	if (!strcmp(action, DBUS_DEVICE_INPUT_ACTION_PRESSED)) {
		return DEVICE_INPUT_ACTION_PRESSED;
	}
	else if (!strcmp(action, DBUS_DEVICE_INPUT_ACTION_HELD)) {
		return DEVICE_INPUT_ACTION_HELD;
	}
	else if (!strcmp(action, DBUS_DEVICE_INPUT_ACTION_RELEASED)) {
		return DEVICE_INPUT_ACTION_RELEASED;
	}
	return DEVICE_INPUT_ACTION_UNKNOWN;
}

void odeviced_input_event_handler(DBusGProxy *proxy,
		char *name, char *action, int duration, gpointer userdata)
{
	void (*callback) (int source, int action, int duration) = NULL;

	callback = userdata;

	if (callback != NULL) {
		(*callback)(odeviced_input_get_source_from_dbus(name),
				odeviced_input_get_action_from_dbus(action),
				duration);
	}
}

