/*
 *  Copyright (C) 2009
 *      Authors (alphabetical) :
 *              Klaus 'mrmoku' Kurzmann <mok@fluxnetz.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Public License as published by
 *  the Free Software Foundation; version 2 of the license.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser Public License for more details.
 */

#ifndef FRAMEWORKD_GLIB_ODEVICED_INPUT_H
#define FRAMEWORKD_GLIB_ODEVICED_INPUT_H

#include <glib.h>
#include <dbus/dbus-glib.h>

#define DBUS_DEVICE_INPUT_SOURCE_AUX   "AUX"
#define DBUS_DEVICE_INPUT_SOURCE_POWER "POWER"

typedef enum {
	DEVICE_INPUT_SOURCE_UNKNOWN = 0,
	DEVICE_INPUT_SOURCE_AUX,
	DEVICE_INPUT_SOURCE_POWER
} DeviceInputSource;

#define DBUS_DEVICE_INPUT_ACTION_PRESSED  "pressed"
#define DBUS_DEVICE_INPUT_ACTION_HELD     "held"
#define DBUS_DEVICE_INPUT_ACTION_RELEASED "released"

typedef enum {
	DEVICE_INPUT_ACTION_UNKNOWN = 0,
	DEVICE_INPUT_ACTION_PRESSED,
	DEVICE_INPUT_ACTION_HELD,
	DEVICE_INPUT_ACTION_RELEASED
} DeviceInputAction;


void odeviced_input_event_handler(DBusGProxy *proxy,
		char *name, char *action, int duration, gpointer userdata);

extern DBusGProxy *odevicedInputBus;

#endif

